#!/bin/bash
#/bin/appex/collect/lw_collect_drop_rt.sh
#v3.00 2021-02-04

PATH=$PATH:/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/bin/appex/:/root/bin
LOGPATH=/var/log/monitor/collect_drop_rt
LOGFILE=${LOGPATH}/collect_drop_rt.log
ROTATEFILE=/etc/logrotate.d/collect_drop_log
PIDFILE=${LOGPATH}/lw_collect_drop_rt.pid

FIRST=1
LAST_LTT_STATS=""
INTERFACES=`ip link | grep ^[0-9] | awk -F: '{print $2}'|grep -v lo`
for i in $INTERFACES; do
    eval $i=""
    eval qdisc_$i=""
done
LAST_TC_STATS=""

appexlist=`ls /proc/net/appex* -d`
count=0
for DR in $appexlist
do
    let "count++"
done
num=`expr $count - 1`

for i in $(seq 0 ${num}); do
    eval LAST_ENGINE_STATS$i=""
done

if [ ! -d ${LOGPATH} ]; then
    mkdir -p ${LOGPATH}
fi

if [ ! -f $PIDFILE ]; then 
    touch $PIDFILE
fi

PID=`cat $PIDFILE`
ps aux|awk '{print $2}'|grep "^$PID$"
if [ $? -eq 0 ]; then
    exit
fi
echo $$ > $PIDFILE

echo "$LOGFILE {"               >> $ROTATEFILE
echo "    hourly"               >> $ROTATEFILE
echo "    size 100M"            >> $ROTATEFILE
echo "    copytruncate"         >> $ROTATEFILE    
echo "    rotate 50"            >> $ROTATEFILE
echo "    compress"             >> $ROTATEFILE
echo "    dateext"              >> $ROTATEFILE
echo "    dateformat  -%Y%m%d%s">> $ROTATEFILE
echo "    notifempty"           >> $ROTATEFILE
echo "    maxage 7"             >> $ROTATEFILE
echo "}"                        >> $ROTATEFILE

if [ -d /proc/ltt ];then
    LTTPATH=/proc/ltt
elif [ -d /proc/net/lw-conf/ltt ];then
    LTTPATH=/proc/net/lw-conf/ltt
fi

while true; do
    BUFF=""
    DIFF=0

    # stats
    TMP=`cat $LTTPATH/stats | grep drop`
    if [ "$LAST_LTT_STATS" != "${TMP}" ]; then
        LAST_LTT_STATS="${TMP}"
        BUFF+="${TMP}\n"
        DIFF=1
    fi

    #ifconfig
    for i in $INTERFACES; do
        TMP=`ifconfig $i | grep dropped`
        eval last_stat=\$$i
        if [ "$last_stat" != "${TMP}" ]; then
            eval $i="\${TMP}"
            BUFF+="-----------$i--------------\n"
            BUFF+="${TMP}\n"
            DIFF=1
        fi
    done

    # qdisc
    for i in $INTERFACES; do
        TMP=`tc -s qdis show dev $i | grep dropped | awk '{print $7}' | awk -F, '{print $1}'`
        eval tc_stats=\$qdisc_$i
        if [ "$tc_stats" != "$TMP" ]; then
            eval qdisc_$i="\${TMP}"
            BUFF+="QDISC $i dropped:${TMP}\n"
            DIFF=1
        fi
    done    
    
    #engine stats
    #echo ---------------engine----------- >> $LOGFILE
    for i in $(seq 0 ${num}); do
        if [ $i -eq 0 ];then
            echo displayLevel: 10 > /proc/net/appex/cmd
            TMP=`cat /proc/net/appex/stats | grep Discards`
        else
            echo displayLevel: 10 > /proc/net/appex$i/cmd
            TMP=`cat /proc/net/appex$i/stats | grep Discards`
        fi

        eval engine_stat=\$LAST_ENGINE_STATS$i
        if [ "$engine_stat" != "${TMP}" ]; then
            eval LAST_ENGINE_STATS$i="\${TMP}"
            BUFF+="-----------appex$i--------------\n"
            BUFF+="${TMP}\n"
            DIFF=1
        fi      
    done

    #cpustats
    #echo ---------------cpu stats----------- >> $LOGFILE
    #mpstat -P ALL >> $LOGFILE
    if [ $FIRST -eq 1 ]; then
        FIRST=0
    else
        if [ $DIFF -eq 1 ]; then
            echo ============================== >> $LOGFILE
            date >> $LOGFILE
            echo -e "$BUFF" >> $LOGFILE
        fi
    fi
    sleep 60
done



