#!/bin/bash
#v1.3
#2020.11.19
#path
MOMITOR_PATH=/var/log/monitor/cpu_monitor
UNFOLDED_PATH=/var/log/monitor/perf_unfold

stack_collapse_file="/bin/appex/monitor/stackcollapse-perf.pl"
flame_graph_file="/bin/appex/monitor/flamegraph.pl"

#Remove function RM_F $1=PATH $2=file name
RM_F(){
    if [ "$1" == "${MOMITOR_PATH}" -o "$1" == "${UNFOLDED_PATH}" ];then
        cd $1
        rm $2 -f
    fi
}

if [ ! -d $UNFOLDED_PATH ]; then
    mkdir -p $UNFOLDED_PATH
fi

cd ${MOMITOR_PATH}
for i in `find ${MOMITOR_PATH} -type f -name "perf.record_cpu*" | xargs`;do
    if [ "${i##*.}" = "unfold" ];then
        continue
    fi
    perf report -n --stdio -i $i > ${UNFOLDED_PATH}/${i:0-22}.perf_report
    perf script -i $i > ${UNFOLDED_PATH}/${i:0-22}.unfold
    ${stack_collapse_file} ${UNFOLDED_PATH}/${i:0-22}.unfold > ${UNFOLDED_PATH}/${i:0-22}.folded
    ${flame_graph_file} ${UNFOLDED_PATH}/${i:0-22}.folded > ${UNFOLDED_PATH}/${i:0-22}_perf.svg
    RM_F ${MOMITOR_PATH} $i
    RM_F ${UNFOLDED_PATH} ${i:0-22}.unfold
    RM_F ${UNFOLDED_PATH} ${i:0-22}.folded
done 

