#!/bin/bash
#/bin/appex/monitor
#v1.2
#2021.01.01
COLLECT_PATH=/var/log/monitor/top_record
script_name=$(basename $0)
g_log_check_day=3
g_last_check_time=0

is_exist=`ps aux | grep ${script_name} | grep -v grep | wc -l` > /dev/null
if [ $is_exist -gt 2 ];then
    echo "$0 already Running"
    exit 1
fi

if [ ! -d $COLLECT_PATH ]; then
    mkdir -p $COLLECT_PATH
fi

while true;
do
    CURRENT_DATE=`date +'%m_%d'`
    LOG_FILE=${COLLECT_PATH}/top_record_${CURRENT_DATE}.log
    echo "==============================" >> $LOG_FILE
    date >> $LOG_FILE
    top -c -b -n 1 | head -40 >> $LOG_FILE

    time_now=`date +%s`
    if [ ${time_now} -gt ${g_last_check_time} ];then
        #check every 12hrs
        g_last_check_time=`expr $time_now + 43200`
        find ${COLLECT_PATH} -maxdepth 1 -type f -mtime +${g_log_check_day} -name "top_record*" -execdir rm -rf {} \;
    fi
    sleep 1
done;
