#!/bin/bash

#set -x
set -e

echo "***********************************"
echo "Stop CPE service and remove CPE DEB"
echo "***********************************"

systemctl stop CPE
dpkg -r CPE

echo "Stop CPE service and remove CPE DEB finished"

echo "***********************************"
echo "Clean CPE log"
echo "***********************************"

rm -f $(ls /var/log/* |grep "/var/log/*cpeagent.log*")
rm -f $(ls /var/log/* |grep "/var/log/*LW_Communication.log*")
rm -f $(ls /var/log/* |grep "/var/log/*messages*")
rm -f $(ls /var/log/* |grep "/var/log/*linkDiagStats.log*")

echo "Clean DEB log finished"

echo "***********************************"
echo "Clean /etc/cpeagent"
echo "***********************************"

if [ "$(ls -l /etc/cpeagent |grep "total" |awk '{print $2}')" = "0" ];then
    echo "/etc/cpeagent is empty"
else
    rm -f $(ls /etc/cpeagent/*)
    echo "Clean /etc/cpeagent finished"
fi

echo "***********************************"
echo "Clean third app Conf"
echo "***********************************"

[ -e /etc/ppp/chat_4g_1 ] && {
    rm -f /etc/appex/chat_4g_1
}

[ -e /etc/quagga/ospfd.conf ] && {
    rm -f /etc/quagga/ospfd.conf
}

[ -e /etc/quagga/zebra.conf ] && {
    rm -f /etc/quagga/zebra.conf
}

[ -e /etc/quagga/bgpd.conf ] && {
    rm -f /etc/quagga/bgpd.conf
}

[ -e /etc/quagga/vtysh.conf ] && {
    rm -f /etc/quagga/vtysh.conf
}

[ -e /bin/appex/ha/HA_alarm.sh ] && {
    rm -f /bin/appex/ha/HA_alarm.sh
}

[ -e /etc/keepalived/keepalived.conf ] && {
    rm -f /etc/keepalived/keepalived.conf
}

[ -e /etc/appex/dnsmasq/hosts ] && {
    rm -f /etc/appex/dnsmasq/hosts
}

[ -e /etc/appex/dnsmasq/dnsmasq.d/Mxhost.conf ] && {
    rm -f /etc/appex/dnsmasq/dnsmasq.d/Mxhost.conf
}

[ -e /etc/appex/dnsmasq/resolv.conf ] && {
    rm -f /etc/appex/dnsmasq/resolv.conf
}

[ -e /etc/appex/dnsmasq/dnsmasq.d/ServerMap.conf ] && {
    rm -f /etc/appex/dnsmasq/dnsmasq.d/ServerMap.conf
}

[ -e /etc/appex/dnsmasq/dnsmasq.d/DnsProxy.conf ] && {
    rm -f /etc/appex/dnsmasq/dnsmasq.d/DnsProxy.conf
}

[ -d /var/log/monitor ] && {
    rm -rf /var/log/monitor
}

[ -e /etc/motd ] && {
    echo "" > /etc/motd
}

echo "Clean third app conf finished"

echo "***********************************"
echo "Reset finished"
echo "***********************************"
