<?php        
error_reporting(E_ERROR | E_WARNING);
ini_set('display_errors', 1);
date_default_timezone_set("PRC");
require_once 'radius/autoload.php';
$FILENAME="/etc/cpeagent/gatewayRadiusAuth.conf";
$NOTIFY_DP="/bin/appex/PortalAuthClient";
$oldurl = $_GET["oldurl"];
$ENABLE_DEBUG=FALSE;
$UNKNOWN_ERROR=251;

function getRealIpAddr(){
    if (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
        $ip=$_SERVER['HTTP_X_FORWARDED_FOR'];
    } else {
        $ip=$_SERVER['REMOTE_ADDR'];
    }
    return $ip;
}

$username = $_POST["username"];
$password = $_POST["password"];
$authpage = "auth.php";

if (empty($username) || empty($password)) {
    header('Location: '.$authpage.'?error=1&oldurl='.$oldurl);
    exit();
}
if (!file_exists($FILENAME)){
    header('Location: '.$authpage.'?error=2&oldurl='.$oldurl);   
    exit();
}
if (!file_exists($NOTIFY_DP)){
    header('Location: '.$authpage.'?error=6&oldurl='.$oldurl);   
    exit();
}

$username = trim($username);
$password = trim($password);
$ip = getRealIpAddr();

if (strpos($username, '\'') !== FALSE) {
    header('Location: '.$authpage.'?error=7&oldurl='.$oldurl);   
    exit();    
}

if (strpos($ip, '\'') !== FALSE) {
    header('Location: '.$authpage.'?error=8&oldurl='.$oldurl);   
    exit();    
}

//read configuration
$server = array();
$port=array();
$secret=array();
$radiusTimeout=5;             //default 5 sec
$encrypt="EAP-MSCHAPV2";      //EAP-MSCHAPV2/MS-CHAP/CHAP/PAP
$attKey=array();
$attValue=array();

$handle = fopen($FILENAME, "r");
if($handle==FALSE) {
    header('Location: '.$authpage.'?error=3&oldurl='.$oldurl);   
    exit();
}
while (!feof($handle)) {
    $line = fgets($handle);
    if (stripos($line, "authserver") !== FALSE) {
        $sub=trim(substr($line,11));
        if (empty($sub)) {
            continue;
        }       
        $item=explode(":",$sub);
        if (count($item)==3) {
            array_push($server,trim($item[0]));
            if (empty($item[1])) {
                array_push($port,1812);
            } else {
                array_push($port,trim($item[1]));
            }      
            array_push($secret, $item[2]);
        }
        else if(count($item)==2) {
            array_push($server,trim($item[0]));
            array_push($port,1812);
            array_push($secret, $item[1]);
        }   
    } else if (stripos($line, "radius_timeout") !== FALSE) {        
        $sub=trim(substr($line,15));
        if (empty($sub)) {
            continue;
        }       
        $radiusTimeout=$sub;        
    } else if (stripos($line, "authmethod") !== FALSE) {   
        $sub=trim(substr($line,11));
        if (empty($sub)) {
            continue;
        }
        $encrypt=trim($sub);
    } else if (stripos($line, "attribute") !== FALSE) {   
        $sub=trim(substr($line,10));
        if (empty($sub)) {
            continue;
        }       
        $item=explode(" ",$sub);
        $item = array_filter($item);  // delete empty
        if (count($item)==2) {
            array_push($attKey,trim($item[0]));
            array_push($attValue,trim($item[1]));
        }
    }
}
fclose($handle);

if($ENABLE_DEBUG) {
    echo "server:";
    print_r($server);    
    echo " port:";
    print_r($port);
    echo " pre-secret:";
    print_r($secret);
    echo " encrypt:";
    print_r($encrypt);
    echo " Att key:";
    print_r($attKey);
    echo " Att value:";
    print_r($attValue);    
}


$encrypt=strtoupper($encrypt);

if (count($server) == 0) {
    header('Location: '.$authpage.'?error=4&oldurl='.$oldurl);   
    exit();
}

$success=0;
for($i=0;$i < count($server); $i++) {
    $radius = new \Dapphp\Radius\Radius();
    $radius->setServer(trim($server[$i]));
    $radius->setSecret($secret[$i]);
    $radius->setAuthenticationPort($port[$i]);  
    $radius->setTimeout($radiusTimeout);
    for ($j=0; $j < count($attKey); $j++) {
        $radius->setAttribute($attKey[$j],$attValue[$j]);
    }
      
    if ($ENABLE_DEBUG) {
        $radius->setDebug();
    }
    
    if ($encrypt==="EAP-MSCHAPV2") {
        $response = $radius->accessRequestEapMsChapV2($username, $password);
    }
    else if($encrypt==="MS-CHAP") {
        $radius->setMSChapPassword($password);
        $response = $radius->accessRequest($username);
    }
    else if($encrypt==="CHAP") {
        $radius->setChapPassword($password); 
        $response = $radius->accessRequest($username);
    }
    else {
        $response = $radius->accessRequest($username, $password);
    }
    if ($response === TRUE) {
        $success = 1;
        break;
    }
}
if ($success === 1) {    
    $cmd = $NOTIFY_DP." -u "."'".$username."'"." -i "."'".$ip."'"." -s ";
    error_log("success ".$cmd);
    exec($cmd, $output, $ret);
    if ($ret != 0) {
        error_log("Failed to exec ".$cmd." ret=".$ret);
        if (!$ENABLE_DEBUG) {
            header('Location: '.$authpage.'?error=5&oldurl='.$oldurl);   
        }                
    } else {
        if (!$ENABLE_DEBUG) {
            header('Location: /success.php?oldurl='.$oldurl);
            exit;
        }        
    }    
} else {    
    $errorCode = $radius->getErrorCode();
    $errorMsg = $radius->getErrorMessage();   
    if ($errorCode == 0) {
        $errorCode = $UNKNOWN_ERROR;        
    }        
    if (empty($errorMsg)) {
        $errorMsg = "Unknown error";
    }
    if ($ENABLE_DEBUG) {
        echo "errormsg:".$errorMsg."<br>";
        echo " code:".$errorCode;
    }
    error_log("errorCode:".$errorCode." errorMsg:".$errorMsg);
    $cmd = $NOTIFY_DP." -u "."'".$username."'"." -i "."'".$ip."'"." -e ".$errorCode;
    exec($cmd, $output, $ret);
    error_log($cmd);
    if ($ret != 0) {
        error_log("Failed to exec ".$cmd." ret=".$ret);
    }
    error_log("authpage:".$authpage);
    if (!$ENABLE_DEBUG) {
        header('Location: '.$authpage.'?msg='.$errorMsg.'&oldurl='.$oldurl);     
    }    
}         
       
?>

