<?php
    $oldurl="";
    $error="";
    $errorMsg="";
    if (isset($_GET['oldurl'])) {   
        $oldurl = $_GET['oldurl'];
    }
    if (empty($oldurl)) {
        $oldurl='http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];  
    }  
    if (isset($_GET['error'])) {   
        $error = $_GET['error'];
    }
    
    if (isset($_GET['msg'])) {   
        $errorMsg = $_GET['msg'];
    }
    $showInfo="";
    if (!empty($errorMsg)) {
        $showInfo = $errorMsg;        
    } else {
        if ($error == 1) {
            $showInfo = "Please input username and password";           
        }
        else if ($error == 2) {
            $showInfo = "No radius configuration file is found, please enable radius authentication from Orchestrator";		
        }
        else if($error == 3) {
            $showInfo = "Failed to open the radius configuration file, please contact the administrator";
        }
        else if ($error == 4) {
            $showInfo = "The authentication server configuration was not found, please contact the administrator to add at least one authentication server";
        }
        else if ($error == 5) {
            $showInfo = "Notify datapath failure, please contact the administrator";
        }
        else if ($error == 6) {
            $showInfo = "The Datapath can't be notified because the executable program is not found or running without permission, please contact the administrator";
        }
        else if ($error == 7) {
            $showInfo = "Username can't contain single quotes";
        }
        else if ($error == 8) {
            $showInfo = "IP address can't contain single quotes";
        }
    }     
?>

<!DOCTYPE html>
<html>
<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Authentication system</title>
  <style>
    /** basic configure */
    * {
      margin: 0;
      padding: 0;
      box-sizing: border-box;
    }
    /** business style */
    .root {
      position: fixed;
      top: 0;
      left: 0;
      width: 100vw;
      height: 100vh;
      overflow-y: auto; 
      background: center / cover no-repeat url(./bg.jpg);
    }
    .container {
      overflow: hidden;
      height:100%;
      position: relative;
      min-height: 600px; 
    }
    .content {
      color: #6A6D70;
      position: absolute;
      top: 50%;
      left: 50%;
      transform: translate(-50%, -50%);
      min-width: 400px;
      width: 26.3%;
      max-width: 500px;
      text-align: center;
    }
    .box {
      position: relative;
      box-shadow: 0 20px 80px 0px rgba(0, 0, 0, 0.3);
      min-height: 354px;
      background: #fff;
      border-radius: 4px;
      margin: 0 auto;
      padding: 2rem 24%;
    }
    .header {
      margin-bottom: 5rem;
    }
    .header h1 {
      font-size: 2.25rem;
    }
    .box .title {
      margin-bottom: 1rem;
    }
    .box .errors {
      margin-bottom: 1.5rem;
      color: #FAAD14;
      min-height: 1px;
    }
    .box .items {
      text-align: left;
      margin-bottom: 2rem;
      font-size: 0.875rem;
    }
    .box .items .item {
      margin-bottom: 1rem;
    }
    .box .key {
      margin-bottom: 0.5rem;
    }
    .box .ipt {
      border:  solid 1px #979797;
      height: 2rem;
      border-radius: 4px;
      width: 100%;
      padding:0.3rem;
    }
    .box .btns .btn {
      height: 2rem;
      width: 100%;
      background: #0A6ED1;
      border-radius: 4px;
      color: #fff;
      border: none;
      outline: none;
      cursor: pointer;
    }
    .footer {
      font-size: 0.875rem;
      color: #74777A;
      position: absolute;
      bottom: 1.2rem;
      width: 100%;
      text-align: center;
    }
  </style>
</head>
<body>
  <form action="/action.php?oldurl=<?php echo htmlspecialchars($oldurl);?>" method="POST" onsubmit="return checked()"> 
  <div class="root">
    <div class="container">
      <div class="content">
        <section class="header">
          <h1>Authentication system</h1>
        </section>
        <div class="box">
          <section class="title">
            <h3>Login</h3>
          </section>
          <div class="errors">
            <?php echo htmlspecialchars($showInfo); ?>
          </div>
          <div class="items">
            <div class="item">
              <p class="key">Username:</p>
              <p class="value">
                <input class="ipt" id="username" name="username" type="text" />
              </p>
            </div>
            <div class="item">
              <p class="key">Password:</p>
              <p class="value">
                <input class="ipt" type="password" id="password" name="password"/>
              </p>
            </div>
          </div>
          <div class="btns">
            <button type="submit" class="btn">Login</button>
          </div>
        </div>
      </div>
      <footer class="footer">
        <span></span>
      </footer>
    </div>
  </div>
  <input type="hidden" name="authpage" value="auth.php" />
  </form>
</body>
</html>
 
<script>
function checked(){
    var user= document.getElementById("username");
    var pd=document.getElementById("password");
    if(user.value == "" || pd.value == ""){
       var obj = document.getElementById("errorInfo");      
       obj.innerHtml="Please input username and password";
       obj.innerText="Please input username and password";
       return false;
    }
    return true;
 }

</script>


 



